(async function (PLUGIN_ID) {
    'use strict';
    var option
    const resp = await kintone.api(kintone.api.url('/k/v1/app/form/fields.json', true), 'GET', {
        "app": kintone.app.getId()
    });
    console.log(resp);
    var Exclusionfield = ["SUBTABLE","CHECK_BOX","MULTI_SELECT","FILE","USER_SELECT","CATEGORY","STATUS_ASSIGNEE","ORGANIZATION_SELECT","GROUP_SELECT","GROUP","MODIFIER","CREATOR","REFERENCE_TABLE","UPDATED_TIME","CREATED_TIME","RECORD_NUMBER","STATUS"]// 選択肢から除外したいフィールドを入れる
    
    //ドロップダウンの中身を作成
    for(var x = Object.values(Object.values(resp.properties)).length - 1; x >= 0; x--){
        if(!Exclusionfield.some(element => element == Object.values(resp.properties)[x].type)){
            //連結するフィールド
            var option = document.createElement('option');
            option.value = Object.values(resp.properties)[x].code;
            option.innerText = Object.values(resp.properties)[x].label;
            //フィールド名とフィールドコードが違えばフィールドコードも表示
            if(Object.values(resp.properties)[x].label != Object.values(resp.properties)[x].code){
                option.innerText = option.innerText + "(" +　Object.values(resp.properties)[x].code + ")";
            }
            document.querySelector("#fieldBtnCode").appendChild(option);
        }
        if(Object.values(resp.properties)[x].type == "SINGLE_LINE_TEXT"){
            //連結先のフィールド
            var option = document.createElement('option');
            option.value = Object.values(resp.properties)[x].code;
            option.innerText = Object.values(resp.properties)[x].label;
            //フィールド名とフィールドコードが違えばフィールドコードも表示
            if(Object.values(resp.properties)[x].label != Object.values(resp.properties)[x].code){
                option.innerText = option.innerText + "(" +　Object.values(resp.properties)[x].code + ")";
            }
            document.querySelector("#linkfield").appendChild(option);
        }
    }
    
    var query;
    var fileElements = document.getElementsByClassName('file'),
    submitElement = document.getElementById('submit'),
    cancelElement = document.getElementById('cancel'),
    config = {},
    configup = {};
    console.log(kintone.plugin.app.getConfig(PLUGIN_ID).key)
    //すでに設定されているものを入力する
    if(kintone.plugin.app.getConfig(PLUGIN_ID).key){
        config = JSON.parse(kintone.plugin.app.getConfig(PLUGIN_ID).key)
        console.log(config);
        document.querySelector("#linkfield").value = config["linkfield"];
        document.querySelector("#fieldBtnCode").value = config["fieldBtnCode"][0];
        for(var othersBtncount = 1; othersBtncount < Object.keys(config["fieldBtnCode"]).length; othersBtncount++){
            fieldadd(document.querySelectorAll("#field-add")[othersBtncount - 1]);
            document.querySelectorAll("#fieldBtnCode")[othersBtncount].value = config["fieldBtnCode"][othersBtncount];
        }
        for(var othersBtncount = 1; othersBtncount < Object.keys(config["linktext"]).length; othersBtncount++){
            document.querySelectorAll("#linktext")[othersBtncount].value = config["linktext"][othersBtncount];
        }
        document.querySelector("#linktype").checked = config["linktype"];
    }
    config = {};
    
    //保存実行
    submitElement.addEventListener('click', function (event) {
        var count = 0;
        if(document.querySelector("#field").value == ""){
            Swal.fire({
                html: '<h1><font color="red" size="4">必須項目が入力されていません。</font></h1>'
                , icon : 'error'
                , toast: true
                , position: 'bottom-start'   //画面左下
                , showConfirmButton: false
                , timer: 3000           //3秒経過後に閉じる
                , width: "20%"
            });
            return false;
        }
        config["linkfield"] = document.querySelector("#linkfield").value;
        query = document.querySelectorAll("#fieldBtnCode");
        config["fieldBtnCode"] = {};
        for(var x = 0; x < query.length; x++){
            if(query[x].value != ""){
                config[query[x].getAttribute('id')][count++] = query[x].value;
            }
        }
        count = 0;
        query = document.querySelectorAll("#linktext");
        config["linktext"] = {};
        for(var x = 0; x < query.length; x++){
            if(document.querySelectorAll("#fieldBtnCode")[x].value != ""){
                config[query[x].getAttribute('id')][count++] = query[x].value;
            }
        }
        config["linktype"] = document.querySelector("#linktype").checked;
        if (!(typeof config === 'object' && config !== null)) return;
        console.log(config);
        configup.key = JSON.stringify(config);
        console.log(configup);
        kintone.plugin.app.setConfig(configup);
    });

    //キャンセルボタン
    cancelElement.addEventListener('click', function (event) {
        window.location.href = '/k/admin/app/' + kintone.app.getId() + '/plugin/';
    });
    
    
    //コピー元のレコードの選択時に表示するフィールドを追加
    document.querySelectorAll("#field-add")[0].addEventListener('click', function (event) {
        fieldadd(this);
    });
    
    //コピー元のレコードの選択時に表示するフィールドを削除
    document.querySelectorAll("#field-remove")[0].addEventListener('click', function fieldclear (event) {
        this.parentElement.parentElement.parentElement.parentElement.parentElement.remove();
        if(document.querySelectorAll("#field-remove").length == 1){
            document.querySelector("#field-remove").style.visibility = "hidden";
        }
    });
    return kintone.promise;

})(kintone.$PLUGIN_ID);

function del(Element){
    Element.remove();
}

//コピー元のレコードの選択時に表示するフィールドを追加
function fieldadd (event) {
    console.log(event);
    document.querySelector("#field-remove").style.visibility = "";
    var nextother = document.querySelector("#field").insertBefore(document.querySelector("#field").children[1].cloneNode(true), event.parentElement.parentElement.parentElement.parentElement.parentElement.nextSibling);
    nextother.children[0].style.display = "";
    nextother.querySelector("#linktext").value = "";
    nextother.querySelector("#field-add").addEventListener('click', function (event) {
        fieldadd(this);
    });
    nextother.querySelector("#field-remove").addEventListener('click', function (event) {
        this.parentElement.parentElement.parentElement.parentElement.parentElement.remove();
        if(document.querySelectorAll("#field-remove").length == 1){
            document.querySelector("#field-remove").style.visibility = "hidden";
        }
    });
}
